##############################################################################
#
# MAKEFILE:
#
#   Makefile for building RYARX14.ARX (The Rockey sample program using ARX).
#
#	Please make sure that the ACAD_DIR variable holds the directory where
#	AutoCAD is installed.
#
#   Compilation: NMAKE -f RYARX14.MAK
#
##############################################################################

ACAD_DIR=D:\ACAD14
ACAD_ADSRX_DIR=$(ACAD_DIR)\adsrx
ACAD_LIB_DIR=$(ACAD_ADSRX_DIR)\lib
ACAD_INCLUDE_DIR=$(ACAD_ADSRX_DIR)\inc

ACAD_LIBS=$(ACAD_LIB_DIR)\acad.lib $(ACAD_LIB_DIR)\rxapi.lib

OBJS=ryarx14.obj ryvc32.obj

all: ryarx14.arx

ryarx14.arx: $(OBJS) ryarx14.def
	link /dll /base:0x1c000000 /entry:"DllEntryPoint@12" \
/subsystem:windows  /nod /out:$@ /def:ryarx14.def $(OBJS) \
"$(ACAD_LIB_DIR)\acad.lib" "$(ACAD_LIB_DIR)\rxapi.lib" \
libc.lib kernel32.lib user32.lib gdi32.lib comdlg32.lib

ryarx14.obj: ryarx14.cpp
        cl -Ox -c -Dacrxapp -Dradpack -I"$(ACAD_INCLUDE_DIR)" ryarx14.cpp

